import { LINE_8, MARKER_CROSS } from "./consts";

export const config = {
	ADDON_PATH: "../../build/cv.node",
	DEFAULT_LINE_TYPE: LINE_8,
	DEFAULT_THICKNESS: 1,
	DEFAULT_MARKER: MARKER_CROSS,
};

export function getAddon() {
	return require(config.ADDON_PATH);
}

export function getConfig<N extends keyof typeof config>(name: N): typeof config[N] { return config[name]; }
export function setConfig<N extends keyof typeof config>(name: N, value: typeof config[N]) { config[name] = value; }

export function CVMat() { return getAddon().Mat; }

export function CVUtil() { return getAddon().util; }
